blob: 2a10047eb710011213024bd0acc57eec87a6f965 [file] [log] [blame]
Linus Torvalds839a7a02005-04-18 12:15:10 -07001#!/bin/sh
2#
Junio C Hamano521003f2005-08-22 21:57:59 -07003# Copyright (c) 2005 Junio C Hamano
4#
5# Fetch one or more remote refs and merge it/them into the current HEAD.
6
SZEDER Gábord8abe142008-04-06 03:23:43 +02007USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
freku045@student.liu.se806f36d2005-12-13 23:30:31 +01008LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
Junio C Hamano533b7032007-01-12 12:52:03 -08009SUBDIRECTORY_OK=Yes
Junio C Hamano8f321a32007-11-06 01:50:02 -080010OPTIONS_SPEC=
Junio C Hamanoae2b0f12005-11-24 00:12:11 -080011. git-sh-setup
Ævar Arnfjörð Bjarmasona9f57862011-05-21 18:43:54 +000012. git-sh-i18n
Ori Avtalionc98d1e42011-07-29 10:19:26 +030013set_reflog_action "pull${1+ $*}"
Jeff King035b5bf2011-10-13 11:59:24 -040014require_work_tree_exists
Junio C Hamano533b7032007-01-12 12:52:03 -080015cd_to_toplevel
Junio C Hamanob10ac502005-08-25 18:15:32 -070016
Matthieu Moyd38a30d2010-01-12 10:54:44 +010017
18die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +000021 die "$(gettext "Pull is not possible because you have unmerged files.
Matthieu Moyd38a30d2010-01-12 10:54:44 +010022Please, fix them up in the work tree, and then use 'git add/rm <file>'
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +000023as appropriate to mark resolution, or use 'git commit -a'.")"
Matthieu Moyd38a30d2010-01-12 10:54:44 +010024 else
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +000025 die "$(gettext "Pull is not possible because you have unmerged files.")"
Matthieu Moyd38a30d2010-01-12 10:54:44 +010026 fi
27}
28
29die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +000031 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32Please, commit your changes before you can merge.")"
Matthieu Moyd38a30d2010-01-12 10:54:44 +010033 else
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +000034 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
Matthieu Moyd38a30d2010-01-12 10:54:44 +010035 fi
36}
37
38test -z "$(git ls-files -u)" || die_conflict
39test -f "$GIT_DIR/MERGE_HEAD" && die_merge
Junio C Hamanod1014a12006-12-31 23:21:50 -080040
Björn Gustavsson13474832009-10-29 23:08:31 +010041strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
Jens Lehmann7dce19d2010-11-12 13:54:52 +010042log_arg= verbosity= progress= recurse_submodules=
Linus Torvalds85808302012-02-11 10:21:03 -080043merge_args= edit=
Johannes Schindelincd67e4d2007-11-28 13:11:07 +000044curr_branch=$(git symbolic-ref -q HEAD)
Stephen Boyd0d12e592010-03-17 22:10:45 -070045curr_branch_short="${curr_branch#refs/heads/}"
Johannes Schindelincd67e4d2007-11-28 13:11:07 +000046rebase=$(git config --bool branch.$curr_branch_short.rebase)
Ævar Arnfjörð Bjarmason6b37dff2011-11-06 10:50:10 +010047if test -z "$rebase"
48then
49 rebase=$(git config --bool pull.rebase)
50fi
Jeff King29609e62010-05-25 02:07:25 -040051dry_run=
David Kastrup822f7c72007-09-23 22:42:08 +020052while :
Junio C Hamano60fb5b22005-09-25 19:43:51 -070053do
54 case "$1" in
Tuncer Ayaz7f87aff2008-11-15 01:14:24 +010055 -q|--quiet)
Tuncer Ayazc6576f92008-11-17 23:09:30 +010056 verbosity="$verbosity -q" ;;
Tuncer Ayaz7f87aff2008-11-15 01:14:24 +010057 -v|--verbose)
Tuncer Ayazc6576f92008-11-17 23:09:30 +010058 verbosity="$verbosity -v" ;;
Tay Ray Chuan98390182010-02-24 20:50:28 +080059 --progress)
60 progress=--progress ;;
Jeff Kingbebd2fd2011-02-20 04:56:56 -050061 --no-progress)
62 progress=--no-progress ;;
SZEDER Gábord8abe142008-04-06 03:23:43 +020063 -n|--no-stat|--no-summary)
Tor Arne Vestbøa334e122009-03-01 22:28:28 +010064 diffstat=--no-stat ;;
SZEDER Gábord8abe142008-04-06 03:23:43 +020065 --stat|--summary)
Tor Arne Vestbøa334e122009-03-01 22:28:28 +010066 diffstat=--stat ;;
SZEDER Gáborefb779f2008-04-06 03:23:46 +020067 --log|--no-log)
68 log_arg=$1 ;;
Junio C Hamano123ee3c2005-11-01 19:30:11 -080069 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
70 no_commit=--no-commit ;;
Lars Hjemli5072a322007-10-29 09:41:18 +010071 --c|--co|--com|--comm|--commi|--commit)
72 no_commit=--commit ;;
Linus Torvalds85808302012-02-11 10:21:03 -080073 -e|--edit)
74 edit=--edit ;;
75 --no-edit)
76 edit=--no-edit ;;
Junio C Hamano7d0c6882006-06-23 01:37:02 -070077 --sq|--squ|--squa|--squas|--squash)
78 squash=--squash ;;
Lars Hjemli5072a322007-10-29 09:41:18 +010079 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
80 squash=--no-squash ;;
81 --ff)
82 no_ff=--ff ;;
83 --no-ff)
84 no_ff=--no-ff ;;
Björn Gustavsson13474832009-10-29 23:08:31 +010085 --ff-only)
86 ff_only=--ff-only ;;
Junio C Hamano60fb5b22005-09-25 19:43:51 -070087 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
88 --strateg=*|--strategy=*|\
89 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
90 case "$#,$1" in
91 *,*=*)
Dennis Stosberg8096fae2006-06-27 18:54:26 +020092 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
Junio C Hamano60fb5b22005-09-25 19:43:51 -070093 1,*)
94 usage ;;
95 *)
96 strategy="$2"
97 shift ;;
98 esac
99 strategy_args="${strategy_args}-s $strategy "
100 ;;
Avery Pennarunee2c7952009-11-25 21:23:57 -0500101 -X*)
102 case "$#,$1" in
103 1,-X)
104 usage ;;
105 *,-X)
Junio C Hamano14e5d402010-01-17 22:31:38 -0800106 xx="-X $(git rev-parse --sq-quote "$2")"
Avery Pennarunee2c7952009-11-25 21:23:57 -0500107 shift ;;
108 *,*)
Junio C Hamano14e5d402010-01-17 22:31:38 -0800109 xx=$(git rev-parse --sq-quote "$1") ;;
Avery Pennarunee2c7952009-11-25 21:23:57 -0500110 esac
111 merge_args="$merge_args$xx "
112 ;;
Johannes Schindelincd67e4d2007-11-28 13:11:07 +0000113 -r|--r|--re|--reb|--reba|--rebas|--rebase)
114 rebase=true
115 ;;
116 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
117 rebase=false
118 ;;
Jens Lehmann7dce19d2010-11-12 13:54:52 +0100119 --recurse-submodules)
120 recurse_submodules=--recurse-submodules
121 ;;
Jens Lehmann8f0700d2011-03-06 23:11:21 +0100122 --recurse-submodules=*)
123 recurse_submodules="$1"
124 ;;
Jens Lehmannbe254a02010-11-11 00:55:02 +0100125 --no-recurse-submodules)
126 recurse_submodules=--no-recurse-submodules
127 ;;
Jeff King29609e62010-05-25 02:07:25 -0400128 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
129 dry_run=--dry-run
130 ;;
Clemens Buchacher87182b12011-10-03 20:21:36 +0200131 -h|--help-all)
Jon Loeliger93d69d82005-11-06 23:30:56 -0600132 usage
133 ;;
David Kastrup822f7c72007-09-23 22:42:08 +0200134 *)
135 # Pass thru anything that may be meant for fetch.
Junio C Hamano619e5a02005-10-03 15:45:44 -0700136 break
Junio C Hamano60fb5b22005-09-25 19:43:51 -0700137 ;;
138 esac
139 shift
140done
141
Junio C Hamano441ed412007-12-28 13:58:43 -0800142error_on_no_merge_candidates () {
143 exec >&2
144 for opt
145 do
146 case "$opt" in
147 -t|--t|--ta|--tag|--tags)
148 echo "Fetching tags only, you probably meant:"
149 echo " git fetch --tags"
150 exit 1
151 esac
152 done
153
Jan Krüger995fc2f2009-11-27 08:17:05 -0600154 if test true = "$rebase"
155 then
156 op_type=rebase
157 op_prep=against
158 else
159 op_type=merge
160 op_prep=with
161 fi
162
Junio C Hamano441ed412007-12-28 13:58:43 -0800163 curr_branch=${curr_branch#refs/heads/}
Junio C Hamanoa6dbf882009-09-13 13:38:48 -0700164 upstream=$(git config "branch.$curr_branch.merge")
Jeff Kinga8c9bef2009-10-05 15:35:16 -0400165 remote=$(git config "branch.$curr_branch.remote")
Junio C Hamano441ed412007-12-28 13:58:43 -0800166
Jeff Kinga8c9bef2009-10-05 15:35:16 -0400167 if [ $# -gt 1 ]; then
Jan Krüger995fc2f2009-11-27 08:17:05 -0600168 if [ "$rebase" = true ]; then
169 printf "There is no candidate for rebasing against "
170 else
171 printf "There are no candidates for merging "
172 fi
173 echo "among the refs that you just fetched."
Jeff Kinga8c9bef2009-10-05 15:35:16 -0400174 echo "Generally this means that you provided a wildcard refspec which had no"
175 echo "matches on the remote end."
176 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
177 echo "You asked to pull from the remote '$1', but did not specify"
Jan Krüger995fc2f2009-11-27 08:17:05 -0600178 echo "a branch. Because this is not the default configured remote"
Jeff Kinga8c9bef2009-10-05 15:35:16 -0400179 echo "for your current branch, you must specify a branch on the command line."
Martin von Zweigbergk15a147e2011-02-09 20:54:02 -0500180 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
181 . git-parse-remote
182 error_on_missing_default_upstream "pull" $op_type $op_prep \
Carlos Martín Nieto3c023962012-03-04 05:41:26 +0100183 "git pull <remote> <branch>"
Junio C Hamanoa6dbf882009-09-13 13:38:48 -0700184 else
Jan Krüger995fc2f2009-11-27 08:17:05 -0600185 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
186 echo "from the remote, but no such ref was fetched."
Matthieu Moy61e61082009-04-08 09:24:03 +0200187 fi
Junio C Hamano441ed412007-12-28 13:58:43 -0800188 exit 1
189}
190
Johannes Schindelinc85c7922008-01-26 18:04:37 +0000191test true = "$rebase" && {
Jeff King19a7fcb2009-08-11 23:27:40 -0400192 if ! git rev-parse -q --verify HEAD >/dev/null
193 then
194 # On an unborn branch
195 if test -f "$GIT_DIR/index"
196 then
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +0000197 die "$(gettext "updating an unborn branch with changes added to the index")"
Jeff King19a7fcb2009-08-11 23:27:40 -0400198 fi
199 else
Ramkumar Ramachandra92c62a32010-10-19 20:09:28 +0530200 require_clean_work_tree "pull with rebase" "Please commit or stash them."
Jeff King19a7fcb2009-08-11 23:27:40 -0400201 fi
Santi Béjard44e7122009-07-19 09:45:16 +0200202 oldremoteref= &&
Johannes Schindelinc85c7922008-01-26 18:04:37 +0000203 . git-parse-remote &&
Santi Béjard44e7122009-07-19 09:45:16 +0200204 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
205 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
206 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
207 do
208 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
209 then
210 oldremoteref="$reflog"
211 break
212 fi
213 done
Johannes Schindelinc85c7922008-01-26 18:04:37 +0000214}
Miklos Vajna2d179852008-12-03 14:26:50 +0100215orig_head=$(git rev-parse -q --verify HEAD)
Jens Lehmann7dce19d2010-11-12 13:54:52 +0100216git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
Jeff King29609e62010-05-25 02:07:25 -0400217test -z "$dry_run" || exit 0
Junio C Hamanob10ac502005-08-25 18:15:32 -0700218
Miklos Vajna2d179852008-12-03 14:26:50 +0100219curr_head=$(git rev-parse -q --verify HEAD)
Junio C Hamanob0ad11e2008-10-14 15:32:20 -0700220if test -n "$orig_head" && test "$curr_head" != "$orig_head"
Junio C Hamanob10ac502005-08-25 18:15:32 -0700221then
222 # The fetch involved updating the current branch.
223
224 # The working tree and the index file is still based on the
225 # $orig_head commit, but we are merging into $curr_head.
226 # First update the working tree to match $curr_head.
227
Jon Seymourc2b1a952011-08-07 21:58:15 +1000228 eval_gettextln "Warning: fetch updated the current branch head.
Ævar Arnfjörð Bjarmason3320a972011-05-21 18:43:57 +0000229Warning: fast-forwarding your working tree from
Jon Seymourc2b1a952011-08-07 21:58:15 +1000230Warning: commit \$orig_head." >&2
Dan Loewenherz7bd93c12009-04-22 21:46:02 -0400231 git update-index -q --refresh
Junio C Hamano5be60072007-07-02 22:52:14 -0700232 git read-tree -u -m "$orig_head" "$curr_head" ||
Ævar Arnfjörð Bjarmason9f35aaa2011-05-21 18:43:56 +0000233 die "$(eval_gettext "Cannot fast-forward your working tree.
Junio C Hamano83231242006-03-22 01:57:11 -0800234After making sure that you saved anything precious from
Ævar Arnfjörð Bjarmason9f35aaa2011-05-21 18:43:56 +0000235$ git diff \$orig_head
Junio C Hamano83231242006-03-22 01:57:11 -0800236output, run
237$ git reset --hard
Ævar Arnfjörð Bjarmason9f35aaa2011-05-21 18:43:56 +0000238to recover.")"
Junio C Hamano83231242006-03-22 01:57:11 -0800239
Junio C Hamanob10ac502005-08-25 18:15:32 -0700240fi
241
Junio C Hamano05dd8e22005-09-25 22:54:23 -0700242merge_head=$(sed -e '/ not-for-merge /d' \
243 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
244 tr '\012' ' ')
Junio C Hamanoe0bfc812005-08-20 02:57:26 -0700245
246case "$merge_head" in
Junio C Hamano521003f2005-08-22 21:57:59 -0700247'')
Junio C Hamano4973aa22009-10-05 12:03:25 -0700248 error_on_no_merge_candidates "$@"
Junio C Hamano521003f2005-08-22 21:57:59 -0700249 ;;
Junio C Hamano60fb5b22005-09-25 19:43:51 -0700250?*' '?*)
Linus Torvaldsd09e79c2006-11-16 11:47:22 -0800251 if test -z "$orig_head"
252 then
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +0000253 die "$(gettext "Cannot merge multiple branches into empty head")"
Linus Torvaldsd09e79c2006-11-16 11:47:22 -0800254 fi
Jay Soffian51b2ead2009-02-18 08:44:02 -0500255 if test true = "$rebase"
256 then
Ævar Arnfjörð Bjarmason85af5f82011-05-21 18:43:55 +0000257 die "$(gettext "Cannot rebase onto multiple branches")"
Jay Soffian51b2ead2009-02-18 08:44:02 -0500258 fi
Junio C Hamano60fb5b22005-09-25 19:43:51 -0700259 ;;
260esac
261
Linus Torvaldsd09e79c2006-11-16 11:47:22 -0800262if test -z "$orig_head"
263then
Junio C Hamanob0ad11e2008-10-14 15:32:20 -0700264 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
Jeff King4b3ffe52011-03-25 14:13:31 -0400265 git read-tree -m -u HEAD || exit 1
Linus Torvaldsd09e79c2006-11-16 11:47:22 -0800266 exit
267fi
268
Elijah Newrencf654262010-08-12 19:50:50 -0600269if test true = "$rebase"
270then
271 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
272 if test "$oldremoteref" = "$o"
273 then
274 unset oldremoteref
275 fi
276fi
277
SZEDER Gáborefb779f2008-04-06 03:23:46 +0200278merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
Junio C Hamano14e5d402010-01-17 22:31:38 -0800279case "$rebase" in
280true)
281 eval="git-rebase $diffstat $strategy_args $merge_args"
282 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
283 ;;
284*)
Linus Torvalds85808302012-02-11 10:21:03 -0800285 eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only"
Jeff Kingbebd2fd2011-02-20 04:56:56 -0500286 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
287 eval="$eval \"\$merge_name\" HEAD $merge_head"
Junio C Hamano14e5d402010-01-17 22:31:38 -0800288 ;;
289esac
290eval "exec $eval"